Index: NEMO/branches/2020/dev_r12558_HPC-08_epico_Extra_Halo/src/OCE/LBC/lbc_nfd_nogather_generic.h90
===================================================================
--- NEMO/branches/2020/dev_r12558_HPC-08_epico_Extra_Halo/src/OCE/LBC/lbc_nfd_nogather_generic.h90	(revision 12799)
+++ NEMO/branches/2020/dev_r12558_HPC-08_epico_Extra_Halo/src/OCE/LBC/lbc_nfd_nogather_generic.h90	(revision 12807)
@@ -97,6 +97,6 @@
                DO jl = 1, ipl; DO jk = 1, ipk
                	  DO jj = 1, nn_hls
-               	     ijj = nlcj -jj +1
-                     DO ji = startloop, nlci
+               	     ijj = jpj -jj +1
+                     DO ji = startloop, jpi
                     	ijt = jpiglo - (ji + nimpp-nn_hls+1 ) - nfiimpp(isendto(1),jpnj) + 4
                      	ARRAY_IN(ji,ijj,jk,jl,jf) = SGN_IN(jf) * ARRAY2_IN(ijt,jj,jk,jl,jf)
@@ -107,7 +107,7 @@
                   DO jl = 1, ipl; DO jk = 1, ipk
                      DO jj = 1, nn_hls
-               	  	ijj = nlcj -jj +1
+               	  	ijj = jpj -jj +1
                	  	DO ii = 0, nn_hls-1
-                  	   ARRAY_IN(ii+1,ijj,jk,jl,jf) = SGN_IN(jf) * ARRAY_IN(2*nn_hls-ii+1,nlcj-2*nn_hls+jj-1,jk,jl,jf)
+                  	   ARRAY_IN(ii+1,ijj,jk,jl,jf) = SGN_IN(jf) * ARRAY_IN(2*nn_hls-ii+1,jpj-2*nn_hls+jj-1,jk,jl,jf)
                   	END DO
                      END DO
@@ -118,19 +118,19 @@
                   IF( nimpp >= jpiglo/2+1 ) THEN
                      startloop = 1
-                  ELSEIF( nimpp+nlci-2*nn_hls+1 >= jpiglo/2+1 .AND. nimpp < jpiglo/2+1 ) THEN
+                  ELSEIF( nimpp+jpi-2*nn_hls+1 >= jpiglo/2+1 .AND. nimpp < jpiglo/2+1 ) THEN
                      startloop = jpiglo/2+1 - nimpp + nn_hls
                   ELSE
-                     startloop = nlci + 1
-                  ENDIF
-                  IF( startloop <= nlci ) THEN
+                     startloop = jpi + 1
+                  ENDIF
+                  IF( startloop <= jpi ) THEN
                      DO jl = 1, ipl; DO jk = 1, ipk
-                        DO ji = startloop, nlci
+                        DO ji = startloop, jpi
                            ijt  = jpiglo - (ji + nimpp -nn_hls+1)- nfiimpp(isendto(1),jpnj) + 4
                            jia  = ji + nimpp -nn_hls
                            ijta = jpiglo - jia + 2
                            IF( ijta >= startloop+nimpp-1 .AND. ijta < jia ) THEN
-                              ARRAY_IN(ji,nlcj-nn_hls,jk,jl,jf) = SGN_IN(jf) * ARRAY_IN(ijta-nimpp+nn_hls,nlcj-nn_hls,jk,jl,jf)
+                              ARRAY_IN(ji,jpj-nn_hls,jk,jl,jf) = SGN_IN(jf) * ARRAY_IN(ijta-nimpp+nn_hls,jpj-nn_hls,jk,jl,jf)
                            ELSE
-                              ARRAY_IN(ji,nlcj-nn_hls,jk,jl,jf) = SGN_IN(jf) * ARRAY2_IN(ijt,nn_hls+1,jk,jl,jf)
+                              ARRAY_IN(ji,jpj-nn_hls,jk,jl,jf) = SGN_IN(jf) * ARRAY2_IN(ijt,nn_hls+1,jk,jl,jf)
                            ENDIF
                         END DO
@@ -139,12 +139,12 @@
                ENDIF
             CASE ( 'U' )                                     ! U-point
-               IF( nimpp + nlci - 2*nn_hls+1 /= jpiglo ) THEN
-                  endloop = nlci
+               IF( nimpp + jpi - 2*nn_hls+1 /= jpiglo ) THEN
+                  endloop = jpi
                ELSE
-                  endloop = nlci - nn_hls
-               ENDIF
-               DO jl = 1, ipl; DO jk = 1, ipk
-		  DO jj = 1, nn_hls
-        	     ijj = nlcj -jj +1
+                  endloop = jpi - nn_hls
+               ENDIF
+               DO jl = 1, ipl; DO jk = 1, ipk
+		  DO jj = 1, nn_hls
+        	     ijj = jpj -jj +1
                      DO ji = 1, endloop
                         iju = jpiglo - (ji + nimpp -nn_hls+1)- nfiimpp(isendto(1),jpnj) + 3
@@ -155,15 +155,15 @@
                IF (nimpp .eq. 1) THEN
 		  DO jj = 1, nn_hls
-		     ijj = nlcj -jj +1
+		     ijj = jpj -jj +1
 		     DO ii = 0, nn_hls-1
-		 	ARRAY_IN(ii+1,ijj,:,:,jf) = SGN_IN(jf) * ARRAY_IN(2*nn_hls-ii,nlcj-2*nn_hls+jj-1,:,:,jf)
+		 	ARRAY_IN(ii+1,ijj,:,:,jf) = SGN_IN(jf) * ARRAY_IN(2*nn_hls-ii,jpj-2*nn_hls+jj-1,:,:,jf)
 		     END DO
                   END DO
                ENDIF
-               IF((nimpp + nlci - 2*nn_hls+1) .eq. jpiglo) THEN
+               IF((nimpp + jpi - 2*nn_hls+1) .eq. jpiglo) THEN
                   DO jj = 1, nn_hls
-               	     ijj = nlcj -jj +1
+               	     ijj = jpj -jj +1
 			DO ii = 1, nn_hls
-		   	   ARRAY_IN(nlci-ii+1,ijj,:,:,jf) = SGN_IN(jf) * ARRAY_IN(nlci-2*nn_hls+ii,nlcj-2*nn_hls+jj-1,:,:,jf)
+		   	   ARRAY_IN(jpi-ii+1,ijj,:,:,jf) = SGN_IN(jf) * ARRAY_IN(jpi-2*nn_hls+ii,jpj-2*nn_hls+jj-1,:,:,jf)
 			END DO
 		  END DO
@@ -171,12 +171,12 @@
                !
                IF ( .NOT. l_fast_exchanges ) THEN
-                  IF( nimpp + nlci - 2*nn_hls+1 /= jpiglo ) THEN
-                     endloop = nlci
-                  ELSE
-                     endloop = nlci - nn_hls
+                  IF( nimpp + jpi - 2*nn_hls+1 /= jpiglo ) THEN
+                     endloop = jpi
+                  ELSE
+                     endloop = jpi - nn_hls
                   ENDIF
                   IF( nimpp >= jpiglo/2 ) THEN
                      startloop = 1
-                  ELSEIF( ( nimpp + nlci - 2*nn_hls+1 >= jpiglo/2 ) .AND. ( nimpp < jpiglo/2 ) ) THEN
+                  ELSEIF( ( nimpp + jpi - 2*nn_hls+1 >= jpiglo/2 ) .AND. ( nimpp < jpiglo/2 ) ) THEN
                      startloop = jpiglo/2 - (nimpp -nn_hls+1) +1
                   ELSE
@@ -190,7 +190,7 @@
                         ijua = jpiglo - jia + 1
                         IF( ijua >= startloop+nimpp-1 .AND. ijua < jia ) THEN
-                           ARRAY_IN(ji,nlcj-nn_hls,jk,jl,jf) = SGN_IN(jf) * ARRAY_IN(ijua-nimpp+nn_hls,nlcj-nn_hls,jk,jl,jf)
+                           ARRAY_IN(ji,jpj-nn_hls,jk,jl,jf) = SGN_IN(jf) * ARRAY_IN(ijua-nimpp+nn_hls,jpj-nn_hls,jk,jl,jf)
                         ELSE
-                           ARRAY_IN(ji,nlcj-nn_hls,jk,jl,jf) = SGN_IN(jf) * ARRAY2_IN(iju,nn_hls+1,jk,jl,jf)
+                           ARRAY_IN(ji,jpj-nn_hls,jk,jl,jf) = SGN_IN(jf) * ARRAY2_IN(iju,nn_hls+1,jk,jl,jf)
                         ENDIF
                      END DO
@@ -208,6 +208,6 @@
                   DO jl = 1, ipl; DO jk = 1, ipk
                	     DO jj = 2, nn_hls+1
-               	  	ijj = nlcj -jj +1
-                     	DO ji = startloop, nlci
+               	  	ijj = jpj -jj +1
+                     	DO ji = startloop, jpi
                            ijt=jpiglo - (ji +nimpp -nn_hls+1)- nfiimpp(isendto(1),jpnj) + 4
                            ARRAY_IN(ji,ijj,jk,jl,jf) = SGN_IN(jf) * ARRAY2_IN(ijt,jj,jk,jl,jf)
@@ -217,27 +217,27 @@
                ENDIF
                DO jl = 1, ipl; DO jk = 1, ipk
-                  DO ji = startloop, nlci
+                  DO ji = startloop, jpi
                      ijt=jpiglo - (ji + nimpp -nn_hls+1)- nfiimpp(isendto(1),jpnj) + 4
-                     ARRAY_IN(ji,nlcj,jk,jl,jf) = SGN_IN(jf) * ARRAY2_IN(ijt,1,jk,jl,jf)
+                     ARRAY_IN(ji,jpj,jk,jl,jf) = SGN_IN(jf) * ARRAY2_IN(ijt,1,jk,jl,jf)
                   END DO
                END DO; END DO
                IF (nimpp .eq. 1) THEN
 		  DO jj = 1, nn_hls
-               	     ijj = nlcj-jj+1
+               	     ijj = jpj-jj+1
                	     DO ii = 0, nn_hls-1
-                        ARRAY_IN(ii+1,ijj,:,:,jf) = SGN_IN(jf) * ARRAY_IN(2*nn_hls-ii+1,nlcj-2*nn_hls+jj-1,:,:,jf)
+                        ARRAY_IN(ii+1,ijj,:,:,jf) = SGN_IN(jf) * ARRAY_IN(2*nn_hls-ii+1,jpj-2*nn_hls+jj-1,:,:,jf)
 		     END DO
 		  END DO
                ENDIF
             CASE ( 'F' )                                     ! F-point
-               IF( nimpp + nlci - 2*nn_hls+1 /= jpiglo ) THEN
-                  endloop = nlci
+               IF( nimpp + jpi - 2*nn_hls+1 /= jpiglo ) THEN
+                  endloop = jpi
                ELSE
-                  endloop = nlci - nn_hls
+                  endloop = jpi - nn_hls
                ENDIF
                IF ( .NOT. l_fast_exchanges ) THEN
                   DO jl = 1, ipl; DO jk = 1, ipk
                	     DO jj = 2, nn_hls+1
-               	  	ijj = nlcj -jj +1
+               	  	ijj = jpj -jj +1
                      	DO ji = 1, endloop
                            iju = jpiglo - (ji + nimpp -nn_hls+1) - nfiimpp(isendto(1),jpnj) + 3
@@ -250,29 +250,29 @@
                   DO ji = 1, endloop
                      iju = jpiglo - (ji + nimpp -nn_hls+1) - nfiimpp(isendto(1),jpnj) + 3
-                     ARRAY_IN(ji,nlcj,jk,jl,jf) = SGN_IN(jf) * ARRAY2_IN(iju,1,jk,jl,jf)
+                     ARRAY_IN(ji,jpj,jk,jl,jf) = SGN_IN(jf) * ARRAY2_IN(iju,1,jk,jl,jf)
                   END DO
                END DO; END DO
 		IF (nimpp .eq. 1) THEN               
 		   DO ii = 1, nn_hls
-	              ARRAY_IN(ii+1,nlcj,:,:,jf) = SGN_IN(jf) * ARRAY_IN(2*nn_hls-ii,nlcj-2*nn_hls-1,:,:,jf)
+	              ARRAY_IN(ii+1,jpj,:,:,jf) = SGN_IN(jf) * ARRAY_IN(2*nn_hls-ii,jpj-2*nn_hls-1,:,:,jf)
 		   END DO
 		   IF ( .NOT. l_fast_exchanges ) THEN
 		      DO jj = 1, nn_hls
-               	 	 ijj = nlcj -jj
+               	 	 ijj = jpj -jj
                		 DO ii = 1, nn_hls
-                    	    ARRAY_IN(2-ii,ijj,:,:,jf) = SGN_IN(jf) * ARRAY_IN(2*nn_hls-ii,nlcj-2*nn_hls+jj-1,:,:,jf)
+                    	    ARRAY_IN(2-ii,ijj,:,:,jf) = SGN_IN(jf) * ARRAY_IN(2*nn_hls-ii,jpj-2*nn_hls+jj-1,:,:,jf)
                  	 END DO
                       END DO
                	   ENDIF
 		ENDIF
-		IF((nimpp + nlci - 2*nn_hls+1 ) .eq. jpiglo) THEN
+		IF((nimpp + jpi - 2*nn_hls+1 ) .eq. jpiglo) THEN
                    DO ii = 1, nn_hls
-	              ARRAY_IN(nlci-ii+1,nlcj,:,:,jf) = SGN_IN(jf) * ARRAY_IN(nlci-2*nn_hls+ii,nlcj-2*nn_hls-1,:,:,jf)
+	              ARRAY_IN(jpi-ii+1,jpj,:,:,jf) = SGN_IN(jf) * ARRAY_IN(jpi-2*nn_hls+ii,jpj-2*nn_hls-1,:,:,jf)
 		   END DO
 		   IF ( .NOT. l_fast_exchanges ) THEN
 		      DO jj = 1, nn_hls
-               	         ijj = nlcj -jj
+               	         ijj = jpj -jj
 	               	 DO ii = 1, nn_hls
-                    	    ARRAY_IN(nlci-ii+1,ijj,:,:,jf) = SGN_IN(jf) * ARRAY_IN(nlci-2*nn_hls+ii,nlcj-2*nn_hls+jj-1,:,:,jf)
+                    	    ARRAY_IN(jpi-ii+1,ijj,:,:,jf) = SGN_IN(jf) * ARRAY_IN(jpi-2*nn_hls+ii,jpj-2*nn_hls+jj-1,:,:,jf)
                      	 END DO
                       END DO
@@ -288,6 +288,6 @@
                DO jl = 1, ipl; DO jk = 1, ipk
 		  DO jj = 1, nn_hls
- 		     ijj = nlcj-jj+1
-		     DO ji = 1, nlci
+ 		     ijj = jpj-jj+1
+		     DO ji = 1, jpi
                      	ijt = jpiglo - ( ji + nimpp -nn_hls+1) - nfiimpp(isendto(1),jpnj) + 3
                      	ARRAY_IN(ji,ijj,jk,jl,jf) = SGN_IN(jf) * ARRAY2_IN(ijt,jj,jk,jl,jf)
@@ -297,12 +297,12 @@
                !
             CASE ( 'U' )                                     ! U-point
-               IF( nimpp + nlci - 2*nn_hls+1 /= jpiglo ) THEN
-                  endloop = nlci
+               IF( nimpp + jpi - 2*nn_hls+1 /= jpiglo ) THEN
+                  endloop = jpi
                ELSE
-                  endloop = nlci - nn_hls
-               ENDIF
-               DO jl = 1, ipl; DO jk = 1, ipk
-		  DO jj = 1, nn_hls
- 		     ijj = nlcj-jj+1
+                  endloop = jpi - nn_hls
+               ENDIF
+               DO jl = 1, ipl; DO jk = 1, ipk
+		  DO jj = 1, nn_hls
+ 		     ijj = jpj-jj+1
                      DO ji = 1, endloop
                         iju = jpiglo- (ji + nimpp -nn_hls+1) - nfiimpp(isendto(1),jpnj) + 2
@@ -311,11 +311,11 @@
                   END DO
                END DO; END DO
-               IF(nimpp + nlci - 2*nn_hls+1 .eq. jpiglo) THEN
+               IF(nimpp + jpi - 2*nn_hls+1 .eq. jpiglo) THEN
                   DO jl = 1, ipl; DO jk = 1, ipk
                      DO jj = 1, nn_hls
-               	        ijj = nlcj-jj+1
+               	        ijj = jpj-jj+1
                         DO ii = 1, nn_hls
-			   iij = nlci-ii+1
-                           ARRAY_IN(iij,ijj,jk,jl,jf) = SGN_IN(jf) * ARRAY_IN(nlci-2*nn_hls+ii-1,nlcj-2*nn_hls+jj,jk,jl,jf)
+			   iij = jpi-ii+1
+                           ARRAY_IN(iij,ijj,jk,jl,jf) = SGN_IN(jf) * ARRAY_IN(jpi-2*nn_hls+ii-1,jpj-2*nn_hls+jj,jk,jl,jf)
                         END DO
                      END DO
@@ -326,6 +326,6 @@
                DO jl = 1, ipl; DO jk = 1, ipk
 		  DO jj = 1, nn_hls
-		     ijj = nlcj -jj +1
-                     DO ji = 1, nlci
+		     ijj = jpj -jj +1
+                     DO ji = 1, jpi
                         ijt = jpiglo - (ji + nimpp -nn_hls+1) - nfiimpp(isendto(1),jpnj) + 3
                         ARRAY_IN(ji,ijj,jk,jl,jf) = SGN_IN(jf) * ARRAY2_IN(ijt,jj,jk,jl,jf)
@@ -337,14 +337,14 @@
                   IF( nimpp >= jpiglo/2+1 ) THEN
                      startloop = 1
-                  ELSEIF( nimpp+nlci-2*nn_hls+1 >= jpiglo/2+1 .AND. nimpp < jpiglo/2+1 ) THEN
+                  ELSEIF( nimpp+jpi-2*nn_hls+1 >= jpiglo/2+1 .AND. nimpp < jpiglo/2+1 ) THEN
                      startloop = jpiglo/2+1 - nimpp + nn_hls
                   ELSE
-                     startloop = nlci + 1
-                  ENDIF
-                  IF( startloop <= nlci ) THEN
-                  DO jl = 1, ipl; DO jk = 1, ipk
-                        DO ji = startloop, nlci
+                     startloop = jpi + 1
+                  ENDIF
+                  IF( startloop <= jpi ) THEN
+                  DO jl = 1, ipl; DO jk = 1, ipk
+                        DO ji = startloop, jpi
                    	   ijt = jpiglo - (ji + nimpp -nn_hls+1) - nfiimpp(isendto(1),jpnj) + 3
-                           ARRAY_IN(ji,nlcj-nn_hls,jk,jl,jf) = SGN_IN(jf) * ARRAY2_IN(ijt,nn_hls+1,jk,jl,jf)
+                           ARRAY_IN(ji,jpj-nn_hls,jk,jl,jf) = SGN_IN(jf) * ARRAY2_IN(ijt,nn_hls+1,jk,jl,jf)
                         END DO
                   END DO; END DO
@@ -353,12 +353,12 @@
                !
             CASE ( 'F' )                               ! F-point
-               IF( nimpp + nlci - 2*nn_hls+1 /= jpiglo ) THEN
-                  endloop = nlci
+               IF( nimpp + jpi - 2*nn_hls+1 /= jpiglo ) THEN
+                  endloop = jpi
                ELSE
-                  endloop = nlci - nn_hls
-               ENDIF
-               DO jl = 1, ipl; DO jk = 1, ipk
-		  DO jj = 1, nn_hls
-		    ijj = nlcj -jj +1
+                  endloop = jpi - nn_hls
+               ENDIF
+               DO jl = 1, ipl; DO jk = 1, ipk
+		  DO jj = 1, nn_hls
+		    ijj = jpj -jj +1
                     DO ji = 1, endloop
                        iju = jpiglo - (ji + nimpp -nn_hls+1) - nfiimpp(isendto(1),jpnj) + 2
@@ -367,11 +367,11 @@
                   END DO
                END DO; END DO
-               IF((nimpp + nlci - 2*nn_hls+1) .eq. jpiglo) THEN
+               IF((nimpp + jpi - 2*nn_hls+1) .eq. jpiglo) THEN
                   DO jl = 1, ipl; DO jk = 1, ipk
                      DO jj = 1, nn_hls
-                        ijj = nlcj -jj +1
+                        ijj = jpj -jj +1
                         DO ii = 1, nn_hls
-			   iij = nlci -ii+1
-                     	   ARRAY_IN(iij,ijj,jk,jl,jf) = SGN_IN(jf) * ARRAY_IN(nlci-2*nn_hls+ii-1,nlcj-2*nn_hls+jj-1,jk,jl,jf)
+			   iij = jpi -ii+1
+                     	   ARRAY_IN(iij,ijj,jk,jl,jf) = SGN_IN(jf) * ARRAY_IN(jpi-2*nn_hls+ii-1,jpj-2*nn_hls+jj-1,jk,jl,jf)
                         END DO
                      END DO
@@ -380,12 +380,12 @@
                !
                IF ( .NOT. l_fast_exchanges ) THEN
-                  IF( nimpp + nlci - 2*nn_hls+1 /= jpiglo ) THEN
-                     endloop = nlci
-                  ELSE
-                     endloop = nlci - nn_hls
+                  IF( nimpp + jpi - 2*nn_hls+1 /= jpiglo ) THEN
+                     endloop = jpi
+                  ELSE
+                     endloop = jpi - nn_hls
                   ENDIF
                   IF( nimpp >= jpiglo/2+1 ) THEN
                      startloop = 1 
-                  ELSEIF( nimpp+nlci-2*nn_hls+1 >= jpiglo/2+1 .AND. nimpp < jpiglo/2+1 ) THEN
+                  ELSEIF( nimpp+jpi-2*nn_hls+1 >= jpiglo/2+1 .AND. nimpp < jpiglo/2+1 ) THEN
                      startloop = jpiglo/2+1 - nimpp + nn_hls
                   ELSE
@@ -396,5 +396,5 @@
                         DO ji = startloop, endloop
                            iju = jpiglo - (ji + nimpp -nn_hls+1) - nfiimpp(isendto(1),jpnj) + 2
-                           ARRAY_IN(ji,nlcj-nn_hls,jk,jl,jf) = SGN_IN(jf) * ARRAY2_IN(iju,nn_hls+1,jk,jl,jf)
+                           ARRAY_IN(ji,jpj-nn_hls,jk,jl,jf) = SGN_IN(jf) * ARRAY2_IN(iju,nn_hls+1,jk,jl,jf)
                         END DO
                      END DO; END DO
Index: NEMO/branches/2020/dev_r12558_HPC-08_epico_Extra_Halo/src/OCE/LBC/lbclnk.F90
===================================================================
--- NEMO/branches/2020/dev_r12558_HPC-08_epico_Extra_Halo/src/OCE/LBC/lbclnk.F90	(revision 12799)
+++ NEMO/branches/2020/dev_r12558_HPC-08_epico_Extra_Halo/src/OCE/LBC/lbclnk.F90	(revision 12807)
@@ -248,5 +248,5 @@
       !
       INTEGER ::   ji, jj, jr
-      INTEGER ::   ierr, itaille, ildi, ilei, iilb
+      INTEGER ::   ierr, itaille, iis0, iie0, iilb
       INTEGER ::   ipj, ij, iproc
       !
@@ -282,9 +282,9 @@
       DO jr = 1, ndim_rank_north            ! recover the global north array
          iproc = nrank_north(jr) + 1
-         ildi = nldit (iproc)
-         ilei = nleit (iproc)
+         iis0 = nis0all(iproc)
+         iie0 = nie0all(iproc)
          iilb = nimppt(iproc)
          DO jj = 1-kextj, ipj+kextj
-            DO ji = ildi, ilei
+            DO ji = iis0, iie0
                ztab_e(ji+iilb-1,jj) = znorthgloio_e(ji,jj,jr)
             END DO
@@ -396,5 +396,5 @@
       SELECT CASE ( nbondi )      ! Read Dirichlet lateral conditions
       CASE ( -1, 0, 1 )                ! all exept 2 (i.e. close case)
-         iihom = jpi-nreci-kexti
+         iihom = jpi - (2 * nn_hls) - kexti
          DO jl = 1, ipreci
             r2dew(:,jl,1) = pt2d(nn_hls+jl,:)
@@ -453,5 +453,5 @@
       !
       IF( nbondj /= 2 ) THEN      ! Read Dirichlet lateral conditions
-         ijhom = jpj-nrecj-kextj
+         ijhom = jpj - ( 2 * nn_hls ) -kextj
          DO jl = 1, iprecj
             r2dsn(:,jl,1) = pt2d(:,ijhom +jl)
Index: NEMO/branches/2020/dev_r12558_HPC-08_epico_Extra_Halo/src/OCE/LBC/mpp_lnk_generic.h90
===================================================================
--- NEMO/branches/2020/dev_r12558_HPC-08_epico_Extra_Halo/src/OCE/LBC/mpp_lnk_generic.h90	(revision 12799)
+++ NEMO/branches/2020/dev_r12558_HPC-08_epico_Extra_Halo/src/OCE/LBC/mpp_lnk_generic.h90	(revision 12807)
@@ -189,26 +189,18 @@
          DO jf = 1, ipf   ;   DO jl = 1, ipl   ;   DO jk = 1, ipk   ;   DO jj = 1, jpj   ;   DO ji = 1, nn_hls
             ARRAY_IN(ji,jj,jk,jl,jf) = zrcv_we(ji,jj,jk,jl,jf)   ! 1 -> nn_hls
-         END DO;   END DO   ;   END DO   ;   END DO   ;   END DO
+         END DO   ;   END DO   ;   END DO   ;   END DO   ;   END DO
       CASE ( jpfillperio )                 ! use east-weast periodicity
          ishift2 = jpi - 2 * nn_hls
          DO jf = 1, ipf   ;   DO jl = 1, ipl   ;   DO jk = 1, ipk   ;   DO jj = 1, jpj   ;   DO ji = 1, nn_hls
             ARRAY_IN(ji,jj,jk,jl,jf) = ARRAY_IN(ishift2+ji,jj,jk,jl,jf)
-         END DO;   END DO   ;   END DO   ;   END DO   ;   END DO
+         END DO   ;   END DO   ;   END DO   ;   END DO   ;   END DO
       CASE ( jpfillcopy  )                 ! filling with inner domain values
-         DO jf = 1, ipf                               ! number of arrays to be treated
-            IF( .NOT. NAT_IN(jf) == 'F' ) THEN        ! do nothing for F point
-               DO jl = 1, ipl   ;   DO jk = 1, ipk   ;   DO jj = 1, jpj   ;   DO ji = 1, nn_hls
-                  ARRAY_IN(ji,jj,jk,jl,jf) = ARRAY_IN(nn_hls+1,jj,jk,jl,jf)
-               END DO   ;   END DO   ;   END DO   ;   END DO
-            ENDIF
-         END DO
+         DO jf = 1, ipf   ;   DO jl = 1, ipl   ;   DO jk = 1, ipk   ;   DO jj = 1, jpj   ;   DO ji = 1, nn_hls
+            ARRAY_IN(ji,jj,jk,jl,jf) = ARRAY_IN(nn_hls+1,jj,jk,jl,jf)
+         END DO   ;   END DO   ;   END DO   ;   END DO   ;   END DO
       CASE ( jpfillcst   )                 ! filling with constant value
-         DO jf = 1, ipf                               ! number of arrays to be treated
-            IF( .NOT. NAT_IN(jf) == 'F' ) THEN        ! do nothing for F point
-               DO jl = 1, ipl   ;   DO jk = 1, ipk   ;   DO jj = 1, jpj   ;   DO ji = 1, nn_hls
-                  ARRAY_IN(ji,jj,jk,jl,jf) = zland
-               END DO;   END DO   ;   END DO   ;   END DO
-            ENDIF
-         END DO
+         DO jf = 1, ipf   ;   DO jl = 1, ipl   ;   DO jk = 1, ipk   ;   DO jj = 1, jpj   ;   DO ji = 1, nn_hls
+            ARRAY_IN(ji,jj,jk,jl,jf) = zland
+         END DO   ;   END DO   ;   END DO   ;   END DO   ;   END DO
       END SELECT
       !
@@ -234,5 +226,5 @@
          DO jf = 1, ipf   ;   DO jl = 1, ipl   ;   DO jk = 1, ipk   ;   DO jj = 1, jpj   ;   DO ji = 1, nn_hls
             ARRAY_IN(ishift+ji,jj,jk,jl,jf) = zland
-         END DO;   END DO   ;   END DO   ;   END DO   ;   END DO
+         END DO   ;   END DO   ;   END DO   ;   END DO   ;   END DO
       END SELECT
       !
@@ -303,26 +295,18 @@
          DO jf = 1, ipf   ;   DO jl = 1, ipl   ;   DO jk = 1, ipk   ;   DO jj = 1, nn_hls   ;   DO ji = 1, jpi
             ARRAY_IN(ji,jj,jk,jl,jf) = zrcv_so(ji,jj,jk,jl,jf)   ! 1 -> nn_hls
-         END DO;   END DO   ;   END DO   ;   END DO   ;   END DO
+         END DO   ;   END DO   ;   END DO   ;   END DO   ;   END DO
       CASE ( jpfillperio )                 ! use north-south periodicity
          ishift2 = jpj - 2 * nn_hls
          DO jf = 1, ipf   ;   DO jl = 1, ipl   ;   DO jk = 1, ipk   ;   DO jj = 1, nn_hls   ;   DO ji = 1, jpi
             ARRAY_IN(ji,jj,jk,jl,jf) = ARRAY_IN(ji,ishift2+jj,jk,jl,jf)
-         END DO;   END DO   ;   END DO   ;   END DO   ;   END DO
+         END DO   ;   END DO   ;   END DO   ;   END DO   ;   END DO
       CASE ( jpfillcopy  )                 ! filling with inner domain values
-         DO jf = 1, ipf                               ! number of arrays to be treated
-            IF( .NOT. NAT_IN(jf) == 'F' ) THEN        ! do nothing for F point
-               DO jl = 1, ipl   ;   DO jk = 1, ipk   ;   DO jj = 1, nn_hls   ;   DO ji = 1, jpi
-                  ARRAY_IN(ji,jj,jk,jl,jf) = ARRAY_IN(ji,nn_hls+1,jk,jl,jf)
-               END DO   ;   END DO   ;   END DO   ;   END DO
-            ENDIF
-         END DO
+         DO jf = 1, ipf   ;   DO jl = 1, ipl   ;   DO jk = 1, ipk   ;   DO jj = 1, nn_hls   ;   DO ji = 1, jpi
+            ARRAY_IN(ji,jj,jk,jl,jf) = ARRAY_IN(ji,nn_hls+1,jk,jl,jf)
+         END DO   ;   END DO   ;   END DO   ;   END DO   ;   END DO
       CASE ( jpfillcst   )                 ! filling with constant value
-         DO jf = 1, ipf                               ! number of arrays to be treated
-            IF( .NOT. NAT_IN(jf) == 'F' ) THEN        ! do nothing for F point
-               DO jl = 1, ipl   ;   DO jk = 1, ipk   ;   DO jj = 1, nn_hls   ;   DO ji = 1, jpi 
-                  ARRAY_IN(ji,jj,jk,jl,jf) = zland
-               END DO;   END DO   ;   END DO   ;   END DO
-            ENDIF
-         END DO
+         DO jf = 1, ipf   ;   DO jl = 1, ipl   ;   DO jk = 1, ipk   ;   DO jj = 1, nn_hls   ;   DO ji = 1, jpi 
+            ARRAY_IN(ji,jj,jk,jl,jf) = zland
+         END DO   ;   END DO   ;   END DO   ;   END DO   ;   END DO
       END SELECT
       !
@@ -340,13 +324,13 @@
          DO jf = 1, ipf   ;   DO jl = 1, ipl   ;   DO jk = 1, ipk   ;   DO jj = 1, nn_hls   ;   DO ji = 1, jpi
             ARRAY_IN(ji,ishift+jj,jk,jl,jf) = ARRAY_IN(ji,ishift2+jj,jk,jl,jf)
-         END DO;   END DO   ;   END DO   ;   END DO   ;   END DO
+         END DO   ;   END DO   ;   END DO   ;   END DO   ;   END DO
       CASE ( jpfillcopy  )                 ! filling with inner domain values
          DO jf = 1, ipf   ;   DO jl = 1, ipl   ;   DO jk = 1, ipk   ;   DO jj = 1, nn_hls   ;   DO ji = 1, jpi
             ARRAY_IN(ji,ishift+jj,jk,jl,jf) = ARRAY_IN(ji,ishift,jk,jl,jf)
-         END DO;   END DO   ;   END DO   ;   END DO   ;   END DO
+         END DO   ;   END DO   ;   END DO   ;   END DO   ;   END DO
       CASE ( jpfillcst   )                 ! filling with constant value
          DO jf = 1, ipf   ;   DO jl = 1, ipl   ;   DO jk = 1, ipk   ;   DO jj = 1, nn_hls   ;   DO ji = 1, jpi
             ARRAY_IN(ji,ishift+jj,jk,jl,jf) = zland
-         END DO;   END DO   ;   END DO   ;   END DO   ;   END DO
+         END DO   ;   END DO   ;   END DO   ;   END DO   ;   END DO
       END SELECT
       !
Index: NEMO/branches/2020/dev_r12558_HPC-08_epico_Extra_Halo/src/OCE/LBC/mpp_nfd_generic.h90
===================================================================
--- NEMO/branches/2020/dev_r12558_HPC-08_epico_Extra_Halo/src/OCE/LBC/mpp_nfd_generic.h90	(revision 12799)
+++ NEMO/branches/2020/dev_r12558_HPC-08_epico_Extra_Halo/src/OCE/LBC/mpp_nfd_generic.h90	(revision 12807)
@@ -56,5 +56,5 @@
       INTEGER  ::   ipi, ipk, ipl, ipf         ! dimension of the input array
       INTEGER  ::   imigr, iihom, ijhom             ! local integers
-      INTEGER  ::   ierr, ibuffsize, ilci, ildi, ilei, iilb
+      INTEGER  ::   ierr, ibuffsize, ijpi, iis0, iie0, iilb
       INTEGER  ::   ij, iproc
       INTEGER, DIMENSION (jpmaxngh)       ::   ml_req_nf   ! for mpi_isend when avoiding mpi_allgather
@@ -111,9 +111,9 @@
                CASE ( 'T' , 'W' ,'U' )                            ! T-, U-, W-point
                   DO ji = 1, nn_hls+1
-                     jj_s(jf,ji) = nlcj - 2*nn_hls +ji -1
+                     jj_s(jf,ji) = jpj - 2*nn_hls +ji -1
                   ENDDO
                CASE ( 'V' , 'F' )                                 ! V-, F-point
                   DO ji = 1, nn_hls+1
-                     jj_s(jf,ji) = nlcj - 2*nn_hls +ji - 2
+                     jj_s(jf,ji) = jpj - 2*nn_hls +ji - 2
                   ENDDO
                END SELECT
@@ -124,10 +124,10 @@
                CASE ( 'T' , 'W' ,'U' )                            ! T-, U-, W-point
                   DO ji = 1, nn_hls
-                     jj_s(jf,ji) = nlcj - 2*nn_hls + ji
+                     jj_s(jf,ji) = jpj - 2*nn_hls + ji
                   ENDDO
                   ipj_s(jf) = nn_hls                  ! need only one line anyway
                CASE ( 'V' , 'F' )                                 ! V-, F-point
                   DO ji = 1, nn_hls+1
-                     jj_s(jf,ji) = nlcj - 2*nn_hls +ji -1
+                     jj_s(jf,ji) = jpj - 2*nn_hls +ji -1
                   ENDDO
                END SELECT
@@ -175,10 +175,10 @@
             iproc = nfipproc(isendto(jr),jpnj)
             IF(iproc /= -1) THEN
-               iilb = nimppt(iproc+1)
-               ilci = nlcit (iproc+1)
-               ildi = nldit (iproc+1) + nn_hls-1
-               ilei = nleit (iproc+1) + nn_hls-1
-               IF( iilb            ==      1 )   ildi = nn_hls   ! e-w boundary already done -> force to take 1st column
-               IF( iilb + ilci - 1 == jpiglo )   ilei = nlei+1   ! e-w boundary already done -> force to take last column
+               iilb =  nimppt(iproc+1)
+               ijpi =  jpiall(iproc+1)
+               iis0 = nis0all(iproc+1) + nn_hls-1
+               iie0 = nie0all(iproc+1) + nn_hls-1
+               IF( iilb            ==      1 )   iis0 = nn_hls   ! e-w boundary already done -> force to take 1st column
+               IF( iilb + ijpi - 1 == jpiglo )   iie0 = Nie0+1   ! e-w boundary already done -> force to take last column
                iilb = nfiimpp(isendto(jr),jpnj) - nfiimpp(isendto(1),jpnj)
             ENDIF
@@ -190,5 +190,5 @@
                   DO jl = 1, ipl
                      DO jk = 1, ipk
-                        DO ji = ildi, ilei
+                        DO ji = iis0, iie0
                            ztabr(iilb-nn_hls+1+ji,jj,jk,jl,jf) = zfoldwk(ji,js,jk,jl,1)
                         END DO
@@ -200,5 +200,5 @@
                   DO jl = 1, ipl
                      DO jk = 1, ipk
-                        DO ji = ildi, ilei
+                        DO ji = iis0, iie0
                            ztabr(iilb-nn_hls+1+ji,jj,jk,jl,jf) = ARRAY_IN(ji,jj_s(jf,jj),jk,jl,jf)
                         END DO
@@ -233,6 +233,6 @@
             DO jl = 1, ipl
                DO jk = 1, ipk
-                  DO jj = nlcj - ijpj +1, nlcj
-                     ij = jj - nlcj + ijpj
+                  DO jj = jpj - ijpj +1, jpj
+                     ij = jj - jpj + ijpj
                      znorthloc(1:jpi,ij,jk,jl,jf) = ARRAY_IN(1:jpi,jj,jk,jl,jf)
                   END DO
@@ -262,15 +262,15 @@
          DO jr = 1, ndim_rank_north         ! recover the global north array
             iproc = nrank_north(jr) + 1
-            iilb  = nimppt(iproc)
-            ilci  = nlcit (iproc)
-            ildi  = nldit (iproc)
-            ilei  = nleit (iproc)
-            IF( iilb            ==      1 )   ildi = 1      ! e-w boundary already done -> force to take 1st column
-            IF( iilb + ilci - 1 == jpiglo )   ilei = ilci   ! e-w boundary already done -> force to take last column
+            iilb  =  nimppt(iproc)
+            ijpi  =  jpiall(iproc)
+            iis0  = nis0all(iproc)
+            iie0  = nie0all(iproc)
+            IF( iilb            ==      1 )   iis0 = 1      ! e-w boundary already done -> force to take 1st column
+            IF( iilb + ijpi - 1 == jpiglo )   iie0 = ijpi   ! e-w boundary already done -> force to take last column
             DO jf = 1, ipf
                DO jl = 1, ipl
                   DO jk = 1, ipk
                      DO jj = 1, ijpj
-                        DO ji = ildi, ilei
+                        DO ji = iis0, iie0
                            ztab(ji+iilb-1,jj,jk,jl,jf) = znorthgloio(ji,jj,jk,jl,jf,jr)
                         END DO
@@ -287,7 +287,7 @@
             DO jl = 1, ipl
                DO jk = 1, ipk
-                  DO jj = nlcj-ijpj+1, nlcj             ! Scatter back to ARRAY_IN
-                     ij = jj - nlcj + ijpj
-                     DO ji= 1, nlci
+                  DO jj = jpj-ijpj+1, jpj             ! Scatter back to ARRAY_IN
+                     ij = jj - jpj + ijpj
+                     DO ji= 1, jpi
                         ARRAY_IN(ji,jj,jk,jl,jf) = ztab(ji+nimpp-1,ij,jk,jl,jf)
                      END DO
